HDU-2126 Buy the souvenirs (DP)

77 篇文章 0 订阅

此处有目录↑

Buy the souvenirs

Time Limit: 10000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)


Problem Description
When the winter holiday comes, a lot of people will have a trip. Generally, there are a lot of souvenirs to sell, and sometimes the travelers will buy some ones with pleasure. Not only can they give the souvenirs to their friends and families as gifts, but also can the souvenirs leave them good recollections. All in all, the prices of souvenirs are not very dear, and the souvenirs are also very lovable and interesting. But the money the people have is under the control. They can’t buy a lot, but only a few. So after they admire all the souvenirs, they decide to buy some ones, and they have many combinations to select, but there are no two ones with the same kind in any combination. Now there is a blank written by the names and prices of the souvenirs, as a top coder all around the world, you should calculate how many selections you have, and any selection owns the most kinds of different souvenirs. For instance:



And you have only 7 RMB, this time you can select any combination with 3 kinds of souvenirs at most, so the selections of 3 kinds of souvenirs are ABC (6), ABD (7). But if you have 8 RMB, the selections with the most kinds of souvenirs are ABC (6), ABD (7), ACD (8), and if you have 10 RMB, there is only one selection with the most kinds of souvenirs to you: ABCD (10).
 

Input
For the first line, there is a T means the number cases, then T cases follow.
In each case, in the first line there are two integer n and m, n is the number of the souvenirs and m is the money you have. The second line contains n integers; each integer describes a kind of souvenir. 
All the numbers and results are in the range of 32-signed integer, and 0<=m<=500, 0<n<=30, t<=500, and the prices are all positive integers. There is a blank line between two cases.
 

Output
If you can buy some souvenirs, you should print the result with the same formation as “You have S selection(s) to buy with K kind(s) of souvenirs”, where the K means the most kinds of souvenirs you can buy, and S means the numbers of the combinations you can buy with the K kinds of souvenirs combination. But sometimes you can buy nothing, so you must print the result “Sorry, you can't buy anything.”
 

Sample Input
  
  
2 4 7 1 2 3 4 4 0 1 2 3 4
 

Sample Output
  
  
You have 2 selection(s) to buy with 3 kind(s) of souvenirs. Sorry, you can't buy anything.

题目大意:给定n个不同纪念品的价格和持有的钱,求在购买纪念品最多的情况下的方案数?

起初想到的状态:dp[i][j]表示选了i种不同的纪念品且花费为j时的方案数,最后在最大不同纪念品数上求和即可,但是没想好如何转移(没有把当前方案数保存,每次计算都是覆盖式的),结果总WA,后来看了一下题解,幡然醒悟,感觉dp还需要加强,多训练


解法一:DP O(m*n^2)

设dp[i][j]表示选了i种不同的纪念品且花费不超过j时的方案数,则状态转移方程为:dp[i][j]+=dp[i-1][j-t[k]];

便于状态转移方程的解释:设dp[k][i][j]表示前k种纪念品中选了i种不同的纪念品且花费不超过j时的方案数

进行到第k种纪念品时,dp[k][i][j]可由两个状态转移而来:①dp[k-1][i][j],即第k种纪念品不选;②dp[k-1][i-1][j-t[k]],即选取第k种纪念品

由于进行到第k种纪念品时,只与第k-1种纪念品的状态有关,所以可以像最原始的01背包进行空间上的优化

#include <cstdio>
#include <cstring>
#include <algorithm>

using namespace std;

int n,m,t[35],dp[35][505],mxKind,sum;//dp[i][j]表示选了i种不同的纪念品且花费不超过j时的方案数

int main() {
    int T;
    scanf("%d",&T);
    while(T-->0) {
        scanf("%d%d",&n,&m);
        for(int k=1;k<=n;++k)
            scanf("%d",t+k);
        sort(t+1,t+n+1);//按照升序排序
        mxKind=sum=0;
        for(int k=1;k<=n;++k) {
            sum+=t[k];
            if(sum<=m)//寻找最大的不同纪念品数
                mxKind=k;
        }
        memset(dp,0,sizeof(dp));
        for(int k=m;k>=0;--k)//若要精确知道每个价格的方案数,只需令dp[0][0]=1即可
            dp[0][k]=1;
        for(int k=1;k<=n;++k) {//纪念品
            for(int i=mxKind;i>=1;--i) {//选取的不同纪念品数
                for(int j=m;j>=t[k];--j) {//背包容量
                    dp[i][j]+=dp[i-1][j-t[k]];
                }
            }
        }
        if(mxKind==0)//若最大不同纪念品数为0,则不能买任何东西
            printf("Sorry, you can't buy anything.\n");
        else
            printf("You have %d selection(s) to buy with %d kind(s) of souvenirs.\n",dp[mxKind][m],mxKind);
    }
    return 0;
}

解法二:DP O(n*m)

又看到另一种dp解法,时空复杂度都降低了

感觉可以算是解法一的优化,对解法一中对dp[i][j](选取i种纪念品,花费不超过j时方案数)优化为way[j](花费不超过j时且选取该花费下最大的物品数时的方案数),用dp[j]表示花费不超过j时选取的最大物品数

优化正确性:优化省去了花费不超过j时且选取物品数不为最大物品数的状态,这些均为无效状态,若这些状态形成的花费不超过m时的最大物品数 为最终的最大物品数,则花费不超过j时且选取物品数且取最大物品数时能在m时转移出更大的最大物品数【感觉又没表达好...】


#include <cstdio>
#include <cstring>
#include <algorithm>

using namespace std;

int n,m,t,dp[505],way[505];//dp[i]表示花费不超过i时能选的最多物品数,way[i]表示花费不超过i时选取最多物品的情况下的方案数

int main() {
    int T;
    scanf("%d",&T);
    while(T-->0) {
        scanf("%d%d",&n,&m);
        for(int i=0;i<=m;++i) {
            dp[i]=0;
            way[i]=1;
        }
        for(int k=1;k<=n;++k) {
            scanf("%d",&t);
            for(int j=m;j>=t;--j) {//背包容量
                if(dp[j]==dp[j-t]+1)//如果花费不超过j时的最多物品数 与 花费不超过j-t时的物品数+1 相等,则选取该物品
                    way[j]+=way[j-t];//花费不超过j时选取最多物品数的方案数 再加上 way[j-t]
                else if(dp[j]<dp[j-t]+1) {//如果花费不超过j时的最多物品数 小于 花费不超过j-t时的物品数+1
                    dp[j]=dp[j-t]+1;//更新花费不超过j时的最多物品数为dp[j-t]+1
                    way[j]=way[j-t];//花费不超过j时选取最多物品数的方案数 为 way[j-t]
                }//如果花费不超过j时的最多物品数 大于 花费不超过j-t时的物品数+1,则不进行转移,因为该状态无效
            }
        }
        if(dp[m]==0)//若最大不同纪念品数为0,则不能买任何东西
            printf("Sorry, you can't buy anything.\n");
        else
            printf("You have %d selection(s) to buy with %d kind(s) of souvenirs.\n",way[m],dp[m]);
    }
    return 0;
}


评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值